/*!
  * cu.js
  * This file contains customized functions
  * by AtYS/RG 2023
  */
 
$(document).ready(function ($) { //console.log('document ready !');


  /**
   * Checks if element is overflowed
   *
   * @param {element|string} el    The element to checks
   * @return {boolean}             true or false
   */

  const isOverflowed = (el) => { console.log('el:');console.log($(el));
    console.log('scrollHeight: ' + $(el).prop('scrollHeight'));
    console.log('clientHeight: ' + $(el).prop('clientHeight'));
    console.log('scrollWidth: ' + $(el).prop('scrollWidth'));
    console.log('clientWidth: ' + $(el).prop('clientWidth'));
    if ( $(el).prop('scrollHeight') > $(el).prop('clientHeight') || $(el).prop('scrollWidth') > $(el).prop('clientWidth')) {
      return true;
    }
  };


  /**
   * Checks if element is over max height or over max width
   *
   * @param {element|string} el    The element to checks
   * @return {boolean}             true or false
   */

  const isOverMaxHW = (el) => {
    var mh = $(el).css('max-height').replace('px','');
    var mw = $(el).css('max-width').replace('px','');
    var sh = $(el).prop('scrollHeight');
    var sw = $(el).prop('scrollWidth');
    console.log('el:');console.log($(el));
    console.log('max-height :'+mh);console.log('height: '+sh);
    //console.log('max-width: '+mw);console.log('width: '+sw);

    if((mh && mh < sh) || (mw && mw < sw)) { console.log('isOverMaxHW');
      return true;
    }
  };


  /**
   * Checks if elements having attribute 'data-cu-show' equal to 'ifTargetIsOverflowed'
   * have a target element defined by 'href' attribute with status overflowed
   */
 
  const ifTargetIsOverflowed = () => { console.log('ifTargetIsOverflowed');
    $("[data-cu-show=ifTargetIsOverflowed]").each(function(){
      if(isOverflowed($(this).attr('href'))) { console.log('TargetIsOverflowed: ' + $(this).attr('href'));
        $(this).show();
      }
      else {
        $(this).hide();
      }
    });
  };


  /**
   * Checks if elements having attribute 'data-cu-hide' equal to 'ifTargetOverMaxHW'
   * have a target element defined by 'href' attribute with status over max height or over max width
   */

  const ifTargetOverMaxHW = () => { console.log('ifTargetOverMaxHW');
    $("[data-cu-show=ifTargetOverMaxHW]").each(function(){
      if(isOverMaxHW($(this).attr('href'))) { console.log('TargetIsOverMaxHW: ' + $(this).attr('href'));
        $(this).show();
      }
      else {
        $(this).hide();
      }
    });
  };


  /**
   * Add event listener 'resize' on window to auto adjust overflowed elements
   */

  $( window ).on( "resize", function() {
    console.log("Handler for `resize` called" );
    ifTargetIsOverflowed();
    ifTargetOverMaxHW();
  } );


  /**
   * Init. overflowed elements
   */

  ifTargetIsOverflowed();
  ifTargetOverMaxHW();


  /**
   * Add event listener 'click' on elements having attribute 'data-cu-target-toggle-class'
   * Triggers toggleClass() on the element defined by 'href' attribute
   * with classes defined by 'data-cu-target-toggle-class' attribute
   */

  $("[data-cu-target-toggle-class]").click(function(){ //console.log('href:');console.log($(this).attr('href'));
    $($(this).attr('href')).toggleClass($(this).data('cu-target-toggle-class'));
  });


  /**
   * Change width of element to the half width of content
   * (apply 5% safe margin)
   */

  $(".cu-max-width-half-of-content").each(function(){
    console.log('cu-max-width-half-of-content:');console.log($(this).width());
    $(this).width($(this).width()*.55);
  });


/* dev only */
        //~ const box = element.getBoundingClientRect();

        //~ if (box.left < 0 || box.right > documentWidth) {
function sleep(ms) {
  return new Promise(resolve => setTimeout(resolve, ms));
}
 

});  
