
$(document).ready(function() {
	var bgShadowId = 'bgShadow';
	var modalBoxId = 'modal';
	modalBoxInit(bgShadowId, modalBoxId);
	$('<div />', {'class':'loading loadingstart'}).appendTo('#'+modalBoxId);
	$('<p />').appendTo('#'+modalBoxId);
	//console.log("blogConnector:init");
	$('#blogLoginForm').appendTo('.post-content p:nth-of-type(1)');
	$('#blogLoginForm').submit(function(e) {
		e.preventDefault();
		$('#loginFormAlert').hide();
		$.ajax('http://www.cesl.fr/blog_connect.php?u='+$('#usernameInput').val()+'&w='+$('#passwordInput').val()).done(function (data) {
			//console.log(data);
			if(data == 'fail') {
				modalBoxHide(bgShadowId, modalBoxId);
				$('#blogLoginAlert').fadeIn('slow', function () {
					$(this).delay(5000).fadeOut('slow');
				});
			} else {
				$('#'+modalBoxId+' p').text('Chargement du blog ...');
				modalBoxShow(bgShadowId, modalBoxId);
				$('#blogLoginForm').attr('action', data).off('submit').submit();
			}
		}).fail(function () {
			modalBoxHide(bgShadowId, modalBoxId);
			$('#blogLoginError').fadeIn('slow', function () {
				$(this).delay(5000).fadeOut('slow');
			});
		});
	});
});

function modalBoxInit(bgShadowId, modalBoxId) {
	//console.log('modalBoxInit: bgShadow='+bgShadowId+' modalBoxId='+modalBoxId);
	$('<div />', {id: bgShadowId}).prependTo('body');
	$('<div />', {id: modalBoxId}).prependTo('body');
	modalBoxReposit(bgShadowId, modalBoxId);
	$(window).resize(function () { modalBoxReposit(bgShadowId, modalBoxId); });
	//$('#'+bgShadowId).click(function () { modalBoxHide(bgShadowId, modalBoxId); });
}

function modalBoxReposit(bgShadowId, modalBoxId){
   var winH = $(document).height();
   var winW = $(window).width();
   $('#'+bgShadowId).css({'width':winW,'height':winH});
   var winH = $(window).height();
   $('#'+modalBoxId).css('top', winH/2 - $('#'+modalBoxId).height()/2);
   $('#'+modalBoxId).css('left', winW/2 - $('#'+modalBoxId).width()/2);
   //console.log('bgShadowResize: '+winW+'x'+winH);
}

function modalBoxShow(bgShadowId, modalBoxId) {
   $('#'+bgShadowId).fadeTo(300,0.8);
   $('#'+modalBoxId).show(300);
   //console.log('modalBoxShow');
}

function modalBoxHide(bgShadowId, modalBoxId) {
   $('#'+modalBoxId).hide(300);
   $('#'+bgShadowId).fadeOut(300);
   //console.log('modalBoxHide');
}
