/*
 * This file is part of theme "CESL2019"
 * 
 * */


$(document).ready(function ($) {

	var cusVerticalWhenSmall = {
		condition: "(min-width:500px)",
		element: '.cus-vertical-small',
		classToRemoveIfTrue: 'ui-controlgroup-vertical',
		classToAddIfFalse: 'ui-controlgroup-vertical'
	};
	window.addEventListener('resize', function() {alterClassOnWindowResize(cusVerticalWhenSmall);}, false);
	alterClassOnWindowResize(cusVerticalWhenSmall);

	// réglages des boutons
	// JMR   $("input[type=submit], button").button();
	//~ $("input[type=radio]").buttonset();
	//~ $("input[type=radio]").controlgroup();

	// réglages des selects
	//$('select').selectmenu();

	// Autocomplete Plugin
	$('#q,#query').autocomplete({
		minLength: 3,
		//open: function() {$('.ui-menu').right(5);} ,
		source: website.ajaxsearch,
		select: function(event, ui) {
			$(this).val(ui.item.label);
			$(this).closest("form").submit();
		}
	});

	// #topbanner-container
	//~ $('#data-page .logo').appendTo('#topbanner-container');
	//~ $('#data-page .mascotte').appendTo('#top-polas');
	//~ $('.data .pola').appendTo('#top-polas');
	//~ console.log('#data-season [data-img_class=pola]');
	//~ console.log($('#data-season [data-img_class=pola]'));
	$('#data-season .logo').appendTo('#topbanner-container');
	$('#data-season .mascotte').appendTo('#top-polas');
	$('#data-season .pola').appendTo('#top-polas');
	eEmbeder($('#top-polas .pola'), 'top-pola-img');
	eEmbeder($('#top-polas .top-pola-img'), 'top-pola');

	// .post-image avec src vide (cat/tag/search)
	$('.post-image:not(:has(img))').addClass('post-image-empty');

	// activation de l'image de fond de page
	//console.log('fond-sejour:'+$('#data-sejour .fond:first').length);
	
	/* JMR COMMENTED
	if($('#data-sejour .fond:first').length) {
		$('html').css("background-image", 'url(' + $('#data-sejour .fond:first').attr('src') + ')');
	} else {
		$('.data .fond:first').attr('src', $('.data .fond:first').attr('data-src'));
		$('html').css("background-image", 'url(' + $('.data .fond:first').attr('data-src') + ')');
	}
	*/

});  

$(window).load(function(){
	externalLinks();
});


// Fonction exécutée au redimensionnement
function alterClassOnWindowResize(args) {
	// args.condition
	// args.element
	// args.classToAddIfTrue
	// args.classToAddIfFalse
	// args.classToRemoveIfTrue
	// args.classToRemoveIfFalse
	if(!args.condition) return;
	if(!args.element) return;
	if(window.matchMedia(args.condition).matches) {
		if(args.classToAddIfTrue) $(args.element).addClass(args.classToAddIfTrue);
		if(args.classToRemoveIfTrue) $(args.element).removeClass(args.classToRemoveIfTrue);
	} else {
		if(args.classToAddIfFalse) $(args.element).addClass(args.classToAddIfFalse);
		if(args.classToRemoveIfFalse) $(args.element).removeClass(args.classToRemoveIfFalse);
	}
}

function sejoursSelect(e) {
	//~ ImageResizeKeepRatio($(e));
	$(e).tabs({ 
		/*hide: {effect: "fadeOut", duration: 750},
		show: {effect: "fadeIn", duration: 750},*/
	}).tabs('rotate', 4500);
	//~ }).tabs(); // for test
}


function dcMediaSizeSelect(m, s) {
	if (!s) s = 'sq';
	var mDir     = m.replace(/\\/g, '/').replace(/\/[^\/]*\/?$/, '');
	var mFile    = m.replace(/\\/g,'/').replace( /.*\//, '' );
	var mFileExt = mFile.split('.').pop();
	var mSrc     = mDir + '/.' + mFile.replace('.' + mFileExt, '') + '_' + s + '.' + mFileExt.toLowerCase();
	return(mSrc);
}

function eEmbeder(e, c, t) {
	if(!t) var t='div';
	//~ cpt = 0;
	e.each(function(){
		//~ cpt++;
		//~ f = c; 
		//~ if (c == 'top-pola' && cpt>1 ) f = f + ' w3-hide-small';	// JMR for responsive
		//~ if (c == 'top-pola' && cpt>1 ) f = f + ' w3-hide-medium';	// JMR for responsive: param cpt>X = # diapo
		//~ $(this).parent().append($('<'+t+'>').addClass(f).append($(this)));
		$(this).parent().append($('<'+t+'>').addClass(c).append($(this)));
	});
}

function ImageResizeKeepRatio(e, d) {
	//~ console.log('ImageResizeKeepRatio : ');
	e.find('img').each(function() {
		//~ console.log('Image src : '+$(this).attr('src'));
		//~ console.log('Image class : '+$(this).attr('class'));
		_ImageResizeKeepRatio($(this), d);
	});
}
function ImageResizeKeepRatioLoad(e, d) {
	e.find('img').each(function() {
		//~ console.log('166');
		//console.log($(this));
		$(this).css({'display':'block'});
		$(this).load(function() {
			//~ console.log('170');
			_ImageResizeKeepRatio($(this), d);
		});
		//$(this).css({'display':'block'});
	});
}
function _ImageResizeKeepRatio(t, d) { //console.log('177');
	if(d > 0) {	t.fadeIn(d); } else { t.css({'display':'block'}); }
	var b = t.parent();
	var c = {};
	c.w = b.width();
	c.h = b.height();
	c.ratio = c.h/c.w; //console.log('c.ratio: ' + c.ratio);
	var i = mediaInfo(t); //console.log(i);
	var o = false;
	// ratio < 1 = paysage  ratio > 1 = portrait
	o = (!o && c.ratio >  1 && c.ratio >  i.ratio) ? 'h' : o;
	o = (!o && c.ratio >  1 && c.ratio <  i.ratio) ? 'v' : o;
	o = (!o && c.ratio >  1 && c.ratio == i.ratio) ? 'h' : o;
	o = (!o && c.ratio == 1 && c.ratio >  i.ratio) ? 'h' : o;
	o = (!o && c.ratio == 1 && c.ratio <  i.ratio) ? 'v' : o;
	o = (!o && c.ratio == 1 && c.ratio == i.ratio) ? 'h' : o; // h or v
	o = (!o && c.ratio <  1 && c.ratio >  i.ratio) ? 'h' : o;
	o = (!o && c.ratio <  1 && c.ratio <  i.ratio) ? 'v' : o;
	o = (!o && c.ratio <  1 && c.ratio == i.ratio) ? 'v' : o;
	//console.log('co:'+o+' cw:'+c.w+' ch:'+c.h+' cr:'+c.ratio+' iw:'+i.width+' ih:'+i.height+' ir:'+i.ratio+' src:'+i.src);
	if(o == 'h')  {t.css({'height': c.h+'px'}); t.css('margin-left', (((c.h/i.ratio)-c.w)/-2)+'px');}
	if(o == 'v')  {t.css({'width' : c.w+'px'}); t.css('margin-top',  (((c.w*i.ratio)-c.h)/-2)+'px');}
	//console.log(o);
	t.css({'display':'block'});
	if(d > 0) {	t.fadeIn(d); } else { t.css({'display':'block'}); }
}

function mediaOrientation(i) {
	var r = i.height / i.width;
	if(r < 1)  i.orientation = 'h'; // horizontal
	if(r > 1)  i.orientation = 'v'; //vertical
	if(r == 1) i.orientation = 's'; //square
	return i;
}

function mediaInfo(e) {
	var i = new Image();
	i.src = e.attr("src");
	i = mediaOrientation(i);
	return({width:i.width, height:i.height, ratio:i.height/i.width, src:i.src, orientation:i.orientation});
}




function imgAnimInit(p) {
	var p = $.extend({interval:60, frame:1, iterator:''},p);
	//console.log(p);
	var i = new Image();
	i.src = $(p.element+" img").attr('src');
	//console.log(i.src);
	$(p.element).css('background-image', 'url('+i.src+')');
	$(p.element+" img").remove();
	var frameW = $(p.element).width();
	var frames = (i.width / frameW) - 1;
	return ($.extend({frames: frames, frameW: frameW},p));
}
function imgAnimStart(p) {
	var frame = p.frame;
	return setInterval(function () {
		p.frame = (++frame % p.frames);
		imgAnimChangeFrame(p);			
	}, p.interval);
}
function imgAnimStop(i) {
	clearInterval(i);
}
function imgAnimChangeFrame(p) {
	var frameOffset = p.frame * -p.frameW;
	$(p.element).css('background-position', frameOffset + 'px 0px');
}


function externalLinks() {
	var current_domain = document.domain;
	if (!current_domain || !document.getElementsByTagName) return;
	var hrefels = new Array;
	var hrefelslen = 0;
	var hrefinner = '';
	hrefels = document.getElementsByTagName("a");
	hrefelslen = hrefels.length;
	for (var i = 0; i < hrefelslen; i++) {
		hrefinner = hrefels[i].innerHTML.toLowerCase();
		if ( (hrefels[i].href == '') || (hrefels[i].href.indexOf('javascript') >=0 ) || (hrefinner.indexOf('<a') >= 0) || (hrefels[i].href.indexOf(current_domain) >= 0) || hrefels[i].onclick != null) {
			continue;
		}
		hrefels[i].onclick = function () { window.open(this.href); return false; };
	}
}


/* GMS_selectOptionsUpdate() function for jquery, 2015 by G.MediaStudio/RG
 * 
 * GMS_selectOptionsUpdate(select, optionsData, keepFirst)
 *   select: element select à traiter
 *   optionsData: liste des options (tableau de paires clé/valeur)
 *   keepFirst: si 'true' alors la première ligne d'option est conservée
 *  */
function GMS_selectOptionsUpdate(select, optionsData, keepFirst) {
	if(keepFirst) {keepFirst = $(select).find(' option:first').clone();}
	$(select).html('');
	if(keepFirst) {keepFirst.appendTo(select);}
	if(optionsData.length) {
		$.each(optionsData, function (i, v) {
			$(select).append($('<option>', {value: v.value, html: v.text}));
		});
	}
}


/* GMS_slideShow() plugin for jquery, 2015 by G.MediaStudio/RG
 * 
 * GMS_slideShow(params)
 *   params : {
 *   item: type-element-a-afficher
 *   delay: delai-avant-affichage-element-suivant
 *   effect: 'nom-effet-transition',  
 *   duration: duree-effet-transition-en-millisecondes
 *   }
 *  */
$.fn.GMS_slideShow = function(p){
	var p=$.extend({item: 'img', delay: 3000, effect: 'fade', duration: 500}, p);
	function s(e,p) {
		if(p.effect=='fade') {
			e.find(p.item + ':gt(0)').hide();
			setInterval(function(){
				e.find(p.item + ':first-child').fadeOut(p.duration).next(p.item).fadeIn(p.duration).end().appendTo(e);
			},p.delay);
		}
		if(p.effect=='cross') {
			if(e.css('position') == 'static') e.css('position', 'relative');
			var zindexRef = e.css('z-index') == 'auto' ? 0 : e.css('z-index');
			e.find(p.item).css({'position': 'absolute', 'z-index': zindexRef});
			if(e.find(p.item + '.active').length < 1) e.find(p.item + ':first').addClass('active');
			e.find(p.item + '.active').css('z-index',zindexRef+1);
			setInterval(function(){
				var active = e.find(p.item + '.active');
				var next = (active.next().length > 0) ? active.next() : e.find(p.item + ':first');
				active.fadeOut(p.duration,function(){
					next.css('z-index','+=1').addClass('active');
					active.css('z-index','-=1').show().removeClass('active');
				});
			},p.delay);
		}
		if(p.effect=='slideleft') {
			/* TODO : a tester
			setInterval(function(){    
				c = e.find(">ul");
				i = e.find(">ul>li:first-child");
				alert(e.css("width"));
				e.find("ul li:first-child").animate({"margin-left": -820}, 1000, function(){    
					$(this).css("margin-left",0).appendTo(c);    
				});    
			}, 5000); */
			/*
			setInterval(function(){    
				$(".slideshow ul li:first-child").animate({"margin-left": -820}, 1000, function(){    
					$(this).css("margin-left",0).appendTo(".slideshow ul");    
				});    
			}, 5000);    
			*/
		}
	};
	return this.each(function(){s($(this),p);});
};


$.fn.scrollTo = function(e, d){
	$(this).animate({scrollTop: $(e).offset().top-100}, d);
}	

String.prototype.sansAccent = function(){
	var accent = [
		/[\300-\306]/g, /[\340-\346]/g, // A, a
		/[\310-\313]/g, /[\350-\353]/g, // E, e
		/[\314-\317]/g, /[\354-\357]/g, // I, i
		/[\322-\330]/g, /[\362-\370]/g, // O, o
		/[\331-\334]/g, /[\371-\374]/g, // U, u
		/[\321]/g, /[\361]/g, // N, n
		/[\307]/g, /[\347]/g, // C, c
	];
	var noaccent = ['A','a','E','e','I','i','O','o','U','u','N','n','C','c'];
	var str = this;
	for(var i = 0; i < accent.length; i++) {str = str.replace(accent[i], noaccent[i]);}
	return str;
}



/* 
 * 
 * Background image
 * 
 */

//~ // page_bgInit
//~ function page_bgInit(bgElement, bgData, bgDataSmall) {

	//~ // init.
	//~ // note : viewport_small is global var defined into _js.html
	//~ if (window.matchMedia("(max-width: "+viewport_small+"px)").matches) {
		//~ /* The viewport is less than, or equal to, viewport_small pixels wide*/
		//~ page_bgSet(bgElement, bgDataSmall);
	//~ } else {
		//~ /* The viewport is greater than viewport_small pixels wide */
		//~ page_bgSet(bgElement, bgData);
	//~ }

	//~ // en cas de redimensionement
	//~ $(window).resize(function() {
		//~ if ($(window).width() <= viewport_small){ 
			//~ page_bgSet(bgElement, bgDataSmall);
		//~ } else {
			//~ page_bgSet(bgElement, bgData);
		//~ }  
	//~ });

//~ }


//~ // page_bgSet
//~ function page_bgSet(bgElement, bgData) {
	//~ $(bgElement).css("background-image", 'url(' + $(bgData).data('img_url') + ')');
//~ }

