/*
 * This file is part of theme "CESL2019"
 * 
 * */



/**
* CusToggle Method
**/
(function($){
 	$.fn.cusToggle = function(optionsOrMethod) {

		var args = arguments; //console.log('arguments'); console.log(arguments);
		//~ args[0] = args.length ? args[0] : '';

		if (typeof optionsOrMethod === "string") //console.log(optionsOrMethod);
			this.each(function(_, element){ //console.log(element);
				//~ cusToggleInit.apply($(element), args);
			});
		else
			this.each(function(_, element){ //console.log(element);
				cusToggleInit.apply($(element), args);
			});

		return this;
	};

	function cusToggleInit() { //console.log('*** cusToggleInit ***'); //console.log('groupClass: '+groupClass); console.log(this);
 		arguments[0] = arguments.length ? arguments[0] : '';
 		var args = {};
 		args.contentClass = (typeof arguments[0].contentClass === 'undefined') ? 'cus-toggle-content' : arguments[0].contentClass;
 		args.activeClass = (typeof arguments[0].activeClass === 'undefined') ? 'cus-active' : arguments[0].activeClass;
 		args.showClass = (typeof arguments[0].showClass === 'undefined') ? 'w3-show' : arguments[0].showClass;
 		args.groupClass = (typeof arguments[0].groupClass === 'undefined') ? false : arguments[0].groupClass; //console.log('groupClass: '+groupClass);
		cusToggleOnClickInit(this, args);
		// bind cusToggle buttons states with Checkboxradio states
		if($('#'+$(this).attr('for')).length && $('#'+$(this).attr('for')).get(0).checked) { //console.log($(this).attr('for')+': checked');
			$(this).addClass(args.activeClass);
		}
		// show current item
		if($(this).hasClass(args.activeClass)) {
			cusToggleSelect(this, args);
		}
	}

	function cusToggleOnClickInit(item, args) {
		$(item).on('click', {'args' : args}, function(event) { //console.log('cus-toggle button click'); //console.log('this.id:'+this.id);
			var args = event.data.args;
			if($(this).hasClass(args.activeClass) === false) {
				cusToggleSelect(this, args);
			} else {
				if(!args.groupClass) {
					$(this).removeClass(args.activeClass);
					$('.'+args.showClass+'.'+args.contentClass+'.'+this.id).removeClass(args.showClass);
				}
			}
		});
	}

	function cusToggleSelect(item, args) { //console.log('cusToggleSelect item : '+$(item).attr('id'));
		if(args.groupClass) {
			// remove activeClass & showClass on group's elements who have its
			$('.'+args.groupClass+'.'+args.activeClass).each(function() {
				$(this).removeClass(args.activeClass);
				$('.'+args.showClass+'.'+args.contentClass+'.'+this.id).removeClass(args.showClass);
			});
		}
		// add activeClass on current toggle button
		$(item).addClass(args.activeClass);
		// add showClass on current toggle content
		$('.'+args.contentClass+'.'+$(item).get(0).id).addClass(args.showClass);
	}

})(jQuery)




/**
* CusToggle alone functions
**/

function cusToggleButtonAction(buttonId, buttonGroupClass, contentGroupClass)  {
		cusToggleSwitch(buttonId, buttonGroupClass, contentGroupClass);
		//~ sessionStorage.setItem('stepCurrent', buttonId); //console.log('set stepCurrent value into sessionStorage');
		scrollToElement('.'+buttonId);
}

function cusToggleSwitch(buttonId, buttonGroupClass, contentGroupClass) {
	// buttonId : Id of element, without '#'
	// groupContentSelector : Selector of group content element
	$('.'+buttonGroupClass).removeClass('cus-active');
	$('#'+buttonId).addClass('cus-active');
	$('.'+contentGroupClass+'.cus-active').removeClass('cus-active w3-show');
	$('.'+contentGroupClass+'.'+buttonId).addClass('cus-active w3-show');
}




/**
* Smooth scrolling to a specific element 
**/
function scrollToElement( target, duration ) {
	duration = (typeof duration === 'undefined') ? 800 : duration;
	target = (typeof target === 'undefined') ? '' : target;
	if(target.length) { //console.log(target);console.log(duration);
		//var topAjust = - ($(target).outerHeight(true) - $(target).height());
		var topAjust = -100;
		$("html, body").stop().animate( { scrollTop: $(target).offset().top + topAjust}, duration);
	}
}




/**
* Set a value for an item if it is empty 
**/
function setValueIfEmpty(target, value) { //console.log($(target));
	if(typeof target === 'undefined') return false;
	if(typeof value === 'undefined') return false;
	if(!$(target).val()) {$(target).val(value); return true}
}



/* test js */
